
#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "UIFriends.hpp"

#include "NDrawTree.h"
#include <atlimage.h>
#include "GdiPlusWrapper.h"
#include "TreeDrop.h"

#define  PRESENCE_RESORT_SORT_ORDER_1    100
#define	 PRESENCE_RESORT_SORT_ORDER_2 50
#define  PRESENCE_RESORT_SORT_ORDER_3 0
class CDragData;
class FavoriteController;


static int _stdcall GroupCompare(UINT_PTR, UINT_PTR, UINT_PTR);


class MainFrame;
class CFriendListDragHelper;
class CBuddyTreeCtrl
{
public:
	CBuddyTreeCtrl(MainFrame* pFrame);
	
	~CBuddyTreeCtrl();

	static int __cdecl ItemComareFunc(void *pvlocale,const void *elem1, const void *elem2);
	void ResortBuddyInGroup(int nGroupID);

	void AddBuddy(const NE_MEMBER_DATA *pUserData, int nGroupid, DWORD);
	void AddGroup(CString, CString, int, DWORD, bool bEndDown = false);
	void DeleteGroup(int);
	vector<Node*> GetNodesByUserId(LPCWSTR lpUserId);
	void DeleteBuddy(CString, int);
	void ReplaceGroupName(int, CString);
	void Invalidate();
	void ExPandGroup();
	void DeleteAllItem();
	Node* HitTest(CPoint pt);
	void SetNodeEdit(int nGroupID);
	void PageDown();

	std::vector<Node*> GetSelectedItems();
	std::vector<Node*> GetAllItems();
	void OnRButtonEvent( bool bDown, int nIndex );
	void UpdataAllBuddyImage();
	void UpdataAllBuddyDisplayNames(int nDisplaType);

	Node* GetRootNode();
	CWnd* GetParent();
	void MakeContextMenu(Node* pNode);
	CMenu* CreateUnSelectedMenu( CMenu* pPopup, CMenu& menu );
	CMenu* CreateSelectedMenu( Node* pNode, CMenu* pPopup, CMenu& menu, bool& bShowUserMenu );
	bool IsSelectedItemsSingleType();
	bool IsGroup( int nIndex ); 
	bool IsGroup( Node* pNode );
	void SetController(FavoriteController* favoriteController );
	void MakeMoveGroupMenu( CMenu* pPopup, std::vector<const IGTBuddyUser *> selectedBuddys);
	bool IsSingleSelectedGroup();
	void MakeIPTMenu( NTIPTStatusType iptMyStatus, NTIPTStatusType iptStatusOfBuddy, const NE_MEMBER_DATA* pMembereData, CMenu* pPopup );
	void MakeProfileDlg();
	void MenuCmd( int nCmdID, Node*pNode);
	void MakeChatDlg(BUDDY_SENDACTIONType action = SENDACTION_NONE);
	void MakeSendNoteDlg();
	void MakeSendSMSDlg();
	void CallCompanyPhone(Node* pNode);
	void CallExtensionPhone(Node* pNode);
	void CallConfer( Node* pNode );
	void CallTransfer( Node* pNode );
	void CallIPPhone(Node* pNode);
	void CallCellPhone(Node* pNode);
	void MakeChatHistoryDlg();
	CMenu* CreateGroupMenu( Node* pNode, CMenu* pPopup, CMenu &menu );
	CMenu* CreateUserMenu( CMenu* pPopup, CMenu &menu, Node* pNode );
	void MenuMoveBuddy( UINT nCmdID, int nMenuStartID );
	void MenuCopyBuddy( UINT nCmdID, int nMenuStartID );
	//void MenuMoveBuddy( int nTargetID );
	//void MenuCopyBuddy( int nTargetID );
	void MenuSortGroup(std::vector<const IGTBuddyGroup*> &groupInfo );
	
	void HandleDragBuddy(Node* pNodeTarget, vector<wstring> vecUserID);
	void HandleDragDrop(Node* hotNode);
	Node* GetGroupByID(int nGroupID); 
	void UpdateStaus(LPCWSTR strUserId, const IGTBuddyUser *pUser, const NE_MEMBER_DATA* data);
	Node* NodeDataConvertToNode(const IGTBuddyGroup* pGroup);
	BOOL IsFromRecentContact(Node* NodeDrop);
	FavoriteController*		m_favoriteController;
	std::map<int, Node*> m_mapGroups;	
	MainFrame* m_pFrame;
	
	CFriendListDragHelper* m_friendDragHelper;
	CCriticalSection m_csListAction;

};
